//+------------------------------------------------------------------+
//|                                           Trade_classes_test.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//|     ,            |
//+------------------------------------------------------------------+
#include <Trade\PositionInfo.mqh>     //---  CPositionInfo
#include <Trade\AccountInfo.mqh>      //---  CAccountInf
#include <Trade\SymbolInfo.mqh>       //---  CSymbolInfo
#include <Trade\HistoryOrderInfo.mqh> //---  HistoryOrderInfo
#include <Trade\OrderInfo.mqh>        //---  OrderInfo
#include <Trade\DealInfo.mqh>         //---  DealInfo
#include <Trade\Trade.mqh>            //---  CTrade
//+------------------------------------------------------------------+
//|    CAccountInfo                                 |
//+------------------------------------------------------------------+
void Test_CAccountInfo()
  {
//---   CAccountInfo
   CAccountInfo myaccount;

//---   , , 7770
   long accountno=myaccount.Login();
   Print("Login: ",accountno);

//---  "Demo trading account", "Real trading account"  "Contest trading account"
   string  acc_trading_mode=myaccount.TradeModeDescription();
   Print(" : ",acc_trading_mode);

//---     
   long acct_leverage=myaccount.Leverage();
   Print(" : ",acct_leverage);

 if(myaccount.TradeAllowed())
     {
      //---  
      Print(" ");
     }
   else
     {
      //---  
      Print(" ");
     }
   if(myaccount.TradeExpert())
     {
      //---   
      Print("  ");
     }
   else
     {
      //---   
      Print("  ");
     }

//---      
   double acc_balance=myaccount.Balance();
   Print("    :",acc_balance);

//---      
   double acc_profit=myaccount.Profit();
   Print("    :",acc_profit);

//---      
   double acc_free_margin=myaccount.FreeMargin();
   Print("   :",acc_free_margin);

//---   
   string acc_currency=myaccount.Currency();
   Print(" :",acc_currency);

//---      
   double operation_profit=myaccount.OrderProfitCheck(_Symbol,ORDER_TYPE_BUY,1.0,1.2950,1.3235);
   Print("     EURUSD 1.2950/1.3235: ",operation_profit);

//---   ,    
   double margin_req=myaccount.MarginCheck(_Symbol,ORDER_TYPE_BUY,1.0,SymbolInfoDouble(_Symbol,SYMBOL_ASK));
   Print(" ,    :",margin_req);

//---    ,      
   double f_margin=myaccount.FreeMarginCheck(_Symbol,ORDER_TYPE_BUY,1.0,SymbolInfoDouble(_Symbol,SYMBOL_ASK));
   Print("  ,     : ",f_margin);

//--- ,      
   double max_lot=myaccount.MaxLotCheck(_Symbol,ORDER_TYPE_BUY,SymbolInfoDouble(_Symbol,SYMBOL_ASK));
   Print("     : ",max_lot);

  }
//+------------------------------------------------------------------+
//|    CSymbolInfo                                  |
//+------------------------------------------------------------------+
void Test_CSymbolInfo()
  {
//---   CSymbolInfo
   CSymbolInfo mysymbol;

//---        CSymbolInfo
   mysymbol.Name(_Symbol);
//---    
   mysymbol.Refresh();

//---         CSymbolInfo 
   if(!mysymbol.RefreshRates())
     {
      //---    
      Print("   ");
     }
   else
     {
      Print(" ");
     }

//---     
   if(!mysymbol.IsSynchronized())
     {
      Print("      ");
     }
   else
     {
      Print("     ");
     }

   long max_vol=long(mysymbol.VolumeHigh());
   Print(" : ",max_vol);

   long min_vol=long(mysymbol.VolumeLow());
   Print(" : ",min_vol);

   datetime qtime=mysymbol.Time();
   Print(": ",qtime);

   int spread=mysymbol.Spread();
   Print(": ",spread);

  int stp_level=mysymbol.StopsLevel();
   Print("Stop Level: ",stp_level);

   int frz_level=mysymbol.FreezeLevel();
   Print("Freeze Level: ",frz_level);

   double bid=mysymbol.Bid();
   Print(" Bid: ",bid);

   double max_bid=mysymbol.BidHigh();
   Print("  Bid: ",max_bid);

   double min_bid=mysymbol.BidLow();
   Print("  Bid: ",min_bid);

   double ask=mysymbol.Ask();
   Print(" Ask: ",ask);

   double max_ask=mysymbol.AskHigh();
   Print("  Ask: ",max_ask);

   double min_ask=mysymbol.AskLow();
   Print("  Ask: ",min_ask);

//---  USDJPY  USDCAD  "USD"
   string base_currency=mysymbol.CurrencyBase();
   Print("  : ",base_currency);

   double contract_size=mysymbol.ContractSize();
   Print(" : ",contract_size);
   
 int s_digits=mysymbol.Digits();
   Print(": ",s_digits);

   double s_point=mysymbol.Point();
   Print(" : ",s_point);

   double min_lot =  mysymbol.LotsMin();
   Print(" : ",min_lot);
   
   double max_lot =  mysymbol.LotsMax();
   Print(" : ",max_lot);

   double lot_step=  mysymbol.LotsStep();
   Print("  : ",lot_step);

//    Ask
   double n_price=mysymbol.NormalizePrice(mysymbol.Ask());
   Print("   Ask: ",n_price);
      
   if(mysymbol.Select())
     {
      //   
     }
   else
     {
      //   
     }

   if(!mysymbol.Select())
     {
      //  ,    
      mysymbol.Select(true);
     }
   else
     {
      //    ,
      //    
      mysymbol.Select(false);
     }

   double init_margin=mysymbol.MarginInitial();
   Print(" : ",init_margin);
    
   if(mysymbol.TradeMode()==SYMBOL_TRADE_MODE_FULL)
     {
      //   
     }

   Print("   : ",mysymbol.TradeModeDescription());   
  }
//+------------------------------------------------------------------+
//|    CHistoryOrderInfo                            |
//+------------------------------------------------------------------+
void Test_CHistoryOrderInfo()
  {
//---   CHistoryOrderInfo
   CHistoryOrderInfo myhistory;

//---        
   if(HistorySelect(0,TimeCurrent())) //---    
     {
      //---      
      int tot_hist_orders=HistoryOrdersTotal();

      ulong h_ticket; //---  

      for(int j=0; j<tot_hist_orders; j++)
        {

         h_ticket=HistoryOrderGetTicket(j);

         Print("");
         Print(" ",j+1,"  ",tot_hist_orders);

         if(h_ticket>0)
           {
            //---  
            myhistory.Ticket(h_ticket);
            ulong ticket=myhistory.Ticket();
            Print(" : ",ticket);

            datetime os_time=myhistory.TimeSetup();
            Print("  : ",os_time);

            Print(" : ",myhistory.TypeDescription());

            if(myhistory.Type()==ORDER_TYPE_BUY)
              {
               //---    
               Print("Buy order");
              }
            else
            if(myhistory.Type()==ORDER_TYPE_SELL)
              {
               //---    
               Print("Sell order");
              }

            if(myhistory.State()==ORDER_STATE_REJECTED)
              {
               //---  ,    
               Print(" ,    ");
              }
            //---   
            datetime ot_done=myhistory.TimeDone();
            Print("  : ",ot_done);

            long o_magic=myhistory.Magic();
            Print("Magic : ",ot_done);

            long o_posid=myhistory.PositionId();
            Print("ID : ",o_posid);

            double o_price=myhistory.PriceOpen();
            Print("  ",o_price);

            string o_symbol=myhistory.Symbol();
            Print(": ",o_symbol);
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|    COrderInfo                                   |
//+------------------------------------------------------------------+
void Test_COrderInfo()
  {
//---   COrderInfo
   COrderInfo myorder;

//---        
   if(HistorySelect(0,TimeCurrent())) //---  
     {
      //---    
      int o_total=OrdersTotal();

      for(int j=0; j<o_total; j++)
        {
         //---       Select  COrderInf,
         //---    ,   

         if(myorder.Select(OrderGetTicket(j)))
           {
            //---    ,      

            ulong o_ticket=myorder.Ticket();
            Print(" : ",o_ticket);

            datetime o_setup=myorder.TimeSetup();
            Print("  : ",o_setup);

            string o_typedescr=myorder.TypeDescription();
            Print(" : ",o_typedescr);

            if(myorder.Type()==ORDER_TYPE_BUY_LIMIT)
              {
               //---   Buy Limit order,  ..
               Print("   Buy Limit");
              }

            if(myorder.State()==ORDER_STATE_STARTED)
              {
               //---    ,     
               Print("   ,     ");
              }

            datetime ot_done=myorder.TimeDone();
            Print("  : ",ot_done);

            long o_magic=myorder.Magic();
            Print("Magic : ",o_magic);

            long o_posid=myorder.PositionId();
            Print("ID : ",o_posid);

            double o_price=myorder.PriceOpen();
            Print("  : ",o_price);

            double  s_loss=myorder.StopLoss();
            Print(" Stop Loss : ",s_loss);

            double t_profit=myorder.TakeProfit();
            Print(" Take Profit : ",t_profit);

            double cur_price=myorder.PriceCurrent();
            Print("    : ",cur_price);

            string o_symbol=myorder.Symbol();
            Print("C : ",o_symbol);

            //---   
            myorder.StoreState();

            if(myorder.CheckState()==true)
              {
               //---       (, )
               Print("     .");
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|    CDealInfo                                    |
//+------------------------------------------------------------------+
void Test_CDealInfo()
  {
//---   CDealInfo
   CDealInfo mydeal;

   if(HistorySelect(0,TimeCurrent()))
     {
      //---      
      int tot_deals=HistoryDealsTotal();

      for(int j=0; j<tot_deals; j++)
        {
         Print("");
         Print(" : ",j+1,"  ",tot_deals);
         mydeal.Ticket(HistoryDealGetTicket(j));

         long dealticket=long(mydeal.Ticket());
         Print(" : ",dealticket);

         long deal_order_no=mydeal.Order();
         Print(" ,     : ",deal_order_no);

         datetime d_time=mydeal.Time();
         Print("  : ",d_time);

         string deal_typedescr=mydeal.TypeDescription();
         Print(" : ",deal_typedescr);

         if(mydeal.Type()==DEAL_TYPE_BUY)
           {
            //---   BUY
           }
         string deal_entrydescr=mydeal.EntryDescription();
         Print(" : ",deal_entrydescr);
         
         if(mydeal.Entry()==DEAL_ENTRY_IN)
           {
            //---   IN ()
           }
         
         long d_magic=mydeal.Magic();
         Print("Magic : ",d_magic);

         long d_post_id=mydeal.PositionId();
         Print(" ,    : ",d_post_id);

         double d_price=mydeal.Price();
         Print(" : ",d_price);

         double d_vol=mydeal.Volume();
         Print(" : ",d_vol);

         string d_symbol=mydeal.Symbol();
         Print(" : ",d_symbol);
        }
     }
  }
//+------------------------------------------------------------------+
//|    CCPositionInfo                               |
//+------------------------------------------------------------------+
void Test_CPositionInfo()
  {
//---   CPositionInfo
   CPositionInfo myposition;

   int pos_total=PositionsTotal();
   Print("   : ",pos_total);

   for(int j=0; j<pos_total; j++)
     {
      if(myposition.Select(PositionGetSymbol(j)))
        {
         Print("");
         Print(" ",j+1,"  ",pos_total);

         //---     ,  
         //---        

         datetime pos_time=myposition.Time();
         Print(" : ",pos_time);
         
         string pos_typedescr=myposition.TypeDescription();
         Print(" : ",pos_time);
         
         if(myposition.Type()==POSITION_TYPE_BUY)
           {
            //---   (buy) 
           }

         long pos_magic=myposition.Magic();
         Print("Magic : ",pos_magic);

         double pos_vol=myposition.Volume(); //--- Lots
         Print(" : ",pos_vol);

         double pos_op_price=myposition.PriceOpen();
         Print("  : ",pos_op_price);

         double pos_stoploss=myposition.StopLoss();
         Print(" Stop Loss : ",pos_stoploss);

         double pos_takeprofit=myposition.TakeProfit();
         Print(" Take Profit : ",pos_takeprofit);

         //---    
         myposition.StoreState();

         if(!myposition.CheckState())
           {
            //---              
           }
         string pos_symbol=myposition.Symbol();
         Print(" : ",pos_symbol);
        }
     }
  }
//+------------------------------------------------------------------+
//|    CTrade                                       |
//+------------------------------------------------------------------+
void Test_CTrade()
  {
   CTrade mytrade;            //--- CTrade class object
   CSymbolInfo mysymbol;      //--- CSymbolInfo class object
   CPositionInfo myposition;  //--- CPositionInfo class object

//---        CSymbolInfo
   mysymbol.Name(_Symbol);
   mysymbol.RefreshRates();

   ulong Magic_No=12345;
   mytrade.SetExpertMagicNumber(Magic_No);

   ulong Deviation=100;
   mytrade.SetDeviationInPoints(Deviation);

//---   
   double Lots=0.1;
   double SL = 0;
   double TP = 0;
   int Stoploss=400;
   int Takeprofit=550;

//---   bid,      CSymbolInfo
   double Oprice=mysymbol.Bid()-_Point*550;

//---    (Sell stop)
   mytrade.OrderOpen(_Symbol,ORDER_TYPE_SELL_STOP,Lots,Oprice,Oprice,SL,TP,ORDER_TIME_GTC,0);

//---   

//---            (      COrderInfo). 
//---      Bid/Ask    CSymbolInfo
   for(int j=0; j<OrdersTotal(); j++)
     {
      ulong o_ticket=OrderGetTicket(j);
      if(o_ticket!=0)
        {
         //---   bid,      CSymbolInfo
         Oprice=mysymbol.Bid()-_Point*150;

         SL=NormalizeDouble(Oprice+_Point*Stoploss,_Digits);
         TP=NormalizeDouble(Oprice-_Point*Takeprofit,_Digits);
         //---   Sell Stop 
         mytrade.OrderModify(o_ticket,Oprice,SL,TP,ORDER_TIME_GTC,0);
        }
     }

//---         , 
//---       COrderInfo
   int o_total=OrdersTotal();
   Print("  : ",o_total);

   for(int j=o_total-1; j>=0; j--)
     {
      ulong o_ticket=OrderGetTicket(j);
      Print("");
      Print(" ",j+1,"  ",o_total);
      Print(" : ",o_ticket);
      if(o_ticket>0)
        {
         //---    Sell Stop
         if(!mytrade.OrderDelete(o_ticket))
            Print(mytrade.ResultRetcodeDescription());
        }
     }

//---     
//---        CSymbolInfo    Bid/Ask 
   Lots=0.1;
//--- Stoploss    
   SL=mysymbol.Ask()-Stoploss*_Point;
//--- Takeprofit    
   TP=mysymbol.Ask()+Takeprofit*_Point;
//---   ask,      CSymbolInfo
   Oprice=mysymbol.Ask();
//---    
   mytrade.PositionOpen(_Symbol,ORDER_TYPE_BUY,Lots,Oprice,SL,TP,"Test Buy");

//---        
   mytrade.PrintRequest();
//---     
   mytrade.PrintResult();

   long dl_ticket=long(mytrade.ResultDeal());
   Print("        : ",dl_ticket);

   long o_ticket=long(mytrade.ResultOrder());
   Print("        : ",o_ticket);

   double o_volume=mytrade.ResultVolume();
   Print("  : ",o_volume);

   double r_price=mytrade.ResultPrice();
   Print("  ,  : ",r_price);

   double rq_bid=mytrade.ResultBid();
   Print("   Bid: ",rq_bid);

   double rq_ask=mytrade.ResultAsk();
   Print("   Ask: ",rq_ask);

//---   
   int newStoploss=250;
   int newTakeprofit=500;

   if(myposition.Select(_Symbol))
     {
      //--- newStoploss    
      SL=mysymbol.Ask()-newStoploss*_Point;
      //--- newTakeprofit    
      TP=mysymbol.Ask()+newTakeprofit*_Point;
      //---      
      mytrade.PositionModify(_Symbol,SL,TP);
     }

   Sleep(3000);

//---   
   if(myposition.Select(_Symbol))
     {
      //---      
      //---      
      mytrade.PositionClose(_Symbol);
      Sleep(3000);

      //     ,  
      int return_code=int(mytrade.ResultRetcode());
      string ret_message=mytrade.ResultRetcodeDescription();
      //  
      Print(" : ",return_code,"   : ",ret_message);
     }

  }
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---    CSymbolInfo
   Test_CSymbolInfo();
//---    CHistoryOrderInfo
   Test_CHistoryOrderInfo();
//---    COrderInfo
   Test_COrderInfo();
//---    CDealInfo
   Test_CDealInfo();
//---    CPositionInfo
   Test_CPositionInfo();
//---    CTrade
   Test_CTrade();
  }
//+------------------------------------------------------------------+
